C=======================================================================C
C GUKINE.F - Part of the SOLSPEC GEANT3 application                     C
C-----------------------------------------------------------------------C
C M. R. Moser, University of Bern, Switzerland                          C
C Last modification: 08/26/2002                                         C
C=======================================================================C

#include "geant321/pilot.h"

C=======================================================================C
      SUBROUTINE GUKINE
C-----------------------------------------------------------------------C
C     Generates Kinematics for primary track                            C
C=======================================================================C

#include "geant321/gcbank.inc"
#include "geant321/gcflag.inc"
#include "geant321/gckine.inc"
#include "geant321/gconsp.inc"
#include "geant321/gcscan.inc"
#include "celoss.inc"
#include "pvolum.inc"
#include "solspec.inc"

      CHARACTER*20 CHNPAR
      DIMENSION VERTEX(3),PLAB(3),RNDM(1),UB(10)
      DIMENSION NID1(1000),NID2(10000),NID3(10000)
      DIMENSION NID4(10000),NID5(36000),SDIR(3)
      SAVE NID1, NID2,NID3, NID4,NID5
      DATA NID1/1000*0/NID2/10000*0/NID3/10000*0/NID4/10000*0/
      DATA NID5/36000*0/
      SAVE VERTEX,PLAB
      DATA VERTEX/0.,1.,70./
      DATA PLAB  /3*0./
      COMMON/PRODEVENTS/NPRODEVENTS
     
      IF(SCANFL) THEN
         CALL GSCANK
      ELSE
         DEDL=0.
         IF (ISPECTRUM.NE.0) THEN
          EKIN=COMPUTE_ENERGY(SELEKIN,SELSPECDIFF,SELSPECINT, NSEL)
         ELSE  
          IF(IKINE.EQ.0) THEN
           EKIN=PKINE(1)
          ELSE
           CALL GRNDM(RNDM,1)
           EKIN=PKINE(1)+(PKINE(2)-PKINE(1))*RNDM(1)
          ENDIF
         ENDIF 
         CALL GFPART(IPARTICLE,CHNPAR,ITRTYP,AMASS,CHARGE,TLIFE,UB,NWB)
         ETOT=EKIN+AMASS
         PLAB(3)=SQRT((ETOT+AMASS)*(ETOT-AMASS))
         VERTEX(1)=POSSTART(1)
         VERTEX(2)=POSSTART(2)
         VERTEX(3)=POSSTART(3)
         fac=3.1415926/180.	 
         THETA=THETASTART*fac
         PHI=PHISTART*fac
         SDIR(1)=SIN(theta)*COS(phi)
         SDIR(2)=SIN(theta)*SIN(phi)
         SDIR(3)=COS(theta)
         PLAB(1)=PLAB(3)*SDIR(1)
         PLAB(2)=PLAB(3)*SDIR(2)
         PLAB(3)=PLAB(3)*SDIR(3)
      
         NPRODEVENTS=NPRODEVENTS+1
         CALL GSVERT(VERTEX,0,0,0,0,NVERT)
         CALL GSKINE(PLAB,IPARTICLE,NVERT,0,0,NT)

C --- register primary particle ---
	
         EKININC=EKIN*1000.
         CALL HFF1(1,NID1,EKIN*1000.,1.)
         CALL HFF2(2,NID2,VERTEX(1),VERTEX(2),1.)
         CALL HFF2(3,NID3,VERTEX(2),VERTEX(3),1.)
         CALL HFF2(4,NID4,VERTEX(3),VERTEX(1),1.)
         CALL HFF2(5,NID5,phi/fac,COS(theta),1.)

C --- kinematics debug (controlled by ISWIT(1)) ---

         IF(IDEBUG.EQ.1) THEN
            IF(ISWIT(1).EQ.1) THEN
               CALL GPRINT('VERT',0)
               CALL GPRINT('KINE',0)
            ENDIF
         ENDIF
      ENDIF
      END


C=======================================================================C
      SUBROUTINE PROTON_INTSPEC
C-----------------------------------------------------------------------C
C     Normalizes integral and differential proton spectrum              C
C=======================================================================C

#include "solspec.inc"

      DIMENSION  DATAEKIN(18), DATASPEC(18)

      DATA DATAEKIN/3500.,4500.,5500.,6500.,7500.,8500.,9500.,10500.,
     *      11500.,12500.,13500.,14500.,15500.,16500.,17500.,18500.,
     *      19500.,20500./

      DATA DATASPEC/41.8341,10.7611,3.5371,1.3761,0.6061,0.2931,0.1531,
     *       0.0851,0.0491,0.0301,0.0191,0.0121,0.0082031,0.0056141,
     *       0.0039241,0.0027961,0.0020271,0.0014921/     
        
      EMIN=4000.
      EMAX=20000.
      NPRO=18
      NSEL=18
      CALL COMPUTE_INTSPEC(DATAEKIN,DATASPEC,PROEKIN,PROSPECDIFF,
     *                     PROSPECINT,NPRO, EMIN,EMAX)
      CALL COMPUTE_INTSPEC(DATAEKIN,DATASPEC,SELEKIN,SELSPECDIFF,
     *                     SELSPECINT,NSEL, EMIN,EMAX)
      END 


C=======================================================================C   
      FUNCTION COMPUTE_ENERGY(EK,SPECDIFF,SPECINT,NPOINT)
C-----------------------------------------------------------------------C
C     Computes initial energy                                           C
C=======================================================================C
       
      DIMENSION RNDM(1),EK(50), SPECDIFF(50), SPECINT(50)  

      CALL GRNDM(RNDM,1)
      DO i=2, NPOINT
        IF ((RNDM(1).GE.SPECINT(i-1))
     *                   .AND.(RNDM(1).LE.SPECINT(i))) THEN
        x0=EK(i-1)
        x1=EK(i)
        A0=SPECDIFF(i-1)
        A1=SPECDIFF(i)
        REST=RNDM(1)-SPECINT(i-1)
        Ax=rest*ALOG(A1/A0)/(x1-x0) + A0
        EKIN=((x1-x0)*ALOG(Ax/A0)/ALOG(A1/A0)) + x0
        COMPUTE_ENERGY=EKIN/1000.
        RETURN 
        ENDIF
      ENDDO
      END


C=======================================================================C  
      SUBROUTINE COMPUTE_INTSPEC(DATAEK,DATASPEC,EK,SPECDIFF,
     *                                    SPECINT,NPOINT, EMIN,EMAX)
C-----------------------------------------------------------------------C
C     Computes integral spectrum                                        C
C=======================================================================C

#include "solspec.inc"

      DIMENSION  DATAEK(50), DATASPEC(50), EK(50), SPECDIFF(50)
      DIMENSION  SPECINT(50)
      
      EK(1)=EMIN
      x=EMIN
      x0=DATAEK(1)
      x1=DATAEK(2)
      A0=DATASPEC(1)
      A1=DATASPEC(2)
      SPECDIFF(1)=A0*( (A1/A0) ** ((x-x0)/(x1-x0)) )
      EK(NPOINT)=EMAX
      x=EMAX
      x0=DATAEK(NPOINT-1)
      x1=DATAEK(NPOINT)
      A0=DATASPEC(NPOINT-1)
      A1=DATASPEC(NPOINT)
      SPECDIFF(NPOINT)=A0*( (A1/A0) ** ((x-x0)/(x1-x0)) )
      DO i=2, NPOINT-1
        SPECDIFF(i)=DATASPEC(i)
        EK(i)=DATAEK(i)
      ENDDO
      SPECINT(1)=0.
      DO i=2, NPOINT
        x0=EK(i-1)
        x1=EK(i)
        A0=SPECDIFF(i-1)
        A1=SPECDIFF(i)
        SPECINT(i)=SPECINT(i-1)+ ((x1-x0)*(A1-A0)/ALOG(A1/A0))
      ENDDO
      DO i=1, NPOINT
       SPECDIFF(i)=SPECDIFF(i)/SPECINT(NPOINT)
       SPECINT(i)=SPECINT(i)/SPECINT(NPOINT)
      ENDDO
      END
