C=======================================================================C
C GUSTEP.F - Part of the SOLSPEC GEANT3 application                     C
C-----------------------------------------------------------------------C
C M. R. Moser, University of Bern, Switzerland                          C
C Last modification: 08/26/2002                                         C
C=======================================================================C

#include "geant321/pilot.h"

C=======================================================================C
      SUBROUTINE GUSTEP
C-----------------------------------------------------------------------C
C     User routine called at the end of each tracking step              C
C=======================================================================C      

#include "geant321/gcbank.inc"
#include "geant321/gctmed.inc"
#include "geant321/gckine.inc"
#include "geant321/gcking.inc"
#include "geant321/gcflag.inc"
#include "geant321/gctrak.inc"
#include "geant321/gcvolu.inc"
#include "geant321/gccuts.inc"
#include "geant321/gconsp.inc"
#include "geant321/gcscan.inc"
#include "celoss.inc"
#include "pvolum.inc"
#include "solspec.inc"
      
      DIMENSION NID(1000)
      DIMENSION NID6(50)
      DIMENSION IPARTBIN(20)
      DATA IPARTBIN/1,2,3,0,4,5,0,6,7,0,0,0,8,9,9,0,0,0,0,0/

      IF (SCANFL) THEN
         CALL GSCANU
      ELSE

C --- something generated? ---

         IF (NGKINE.GT.0) THEN
            DO 10 I=1,NGKINE
               CALL GSKING(I)
               IF(ISWIT(9).NE.0)GO TO 10
   10       CONTINUE
         ENDIF
         IF(ISWIT(9).NE.0) GO TO 50
	 
C --- registers and stops particles in the detection layer ---

         NVOL=LVOLUM(NLEVEL)
         IF ((NVOL.EQ.IDETL).AND.(GEKIN.GT.0)) THEN
           EKIN = GEKIN*1000.
           EX = VECT(4)
           EY = VECT(5)
           EZ = VECT(6)
           IDPART = IPART
           ECOST=-EZ
           EPHI=ATAN2(-EY,-EX)
           ITHIST=0
           DO I=0,NRTHETA-1
             THMIN=1.-I/(NRTHETA-1.)-0.5/(NRTHETA-1.)
             THMAX=1.-I/(NRTHETA-1.)+0.5/(NRTHETA-1.)
             IF ((ECOST.GT.THMIN).AND.(ECOST.LE.THMAX)) 
     *        ITHIST=I
           ENDDO
           IPHIST=0
           NRPHIMULT=4*(NRPHI-1)+1
           DO I=0,NRPHIMULT-1
            PHMIN=-pi-pi/(4.*(NRPHI-1.))+I*pi/(2.*(NRPHI-1.))
            PHMAX=-pi+pi/(4.*(NRPHI-1.))+I*pi/(2.*(NRPHI-1.))
            IF ((EPHI.GT.PHMIN).AND.(EPHI.LE.PHMAX)) IPHIST=I
           ENDDO
	  
           IF (IDPART.LE.20) THEN
             IF (IPARTBIN(IDPART).NE.0) THEN
              JHISTO=IPARTBIN(IDPART)*1000+ITHIST*100+IPHIST
              CALL HFF1(JHISTO,NID,EKIN,1.)
              JHISTO=IPARTBIN(IDPART)+10
              CALL HFF1(JHISTO,NID,EKIN,1.)
             ENDIF
           ENDIF
           CALL HFF1(6,NID6,1.*IDPART,1.)
           GEKIN=0.
           VECT(7)=0.
         ENDIF

C --- debugs event ---

        IF (ISONTELDEBUG.NE.0) THEN
         WRITE(6,3111),NLEVEL,NAMES(NLEVEL),NUMBER(2)
         CALL GPCXYZ
        ENDIF  
  50    CALL GDEBUG
       
 3111 FORMAT(I3,1X,A4,1X,I3) 
      ENDIF
 
      END
