C=======================================================================C
C UGEOM.F - Part of the SOLSPEC GEANT3 application                      C
C-----------------------------------------------------------------------C
C M. R. Moser, University of Bern, Switzerland                          C
C Last modification: 08/16/2002                                         C
C=======================================================================C

#include "geant321/pilot.h"

C=======================================================================C
      SUBROUTINE UGEOM
C-----------------------------------------------------------------------C
C     Defines user geometry set up                                      C
C=======================================================================C 

#include "geant321/gcbank.inc"
#include "geant321/gckine.inc"
#include "pvolum.inc"
#include "solspec.inc"
 
      DIMENSION PAR(10)
      DIMENSION AAIR(2), ZAIR(2),WAIR(2)      
      DIMENSION PRESS(101)
      DIMENSION HEIGHT(101)
      DIMENSION DENSITY(101)
      CHARACTER XNR*4
      INTEGER LAY
      REAL DPRESS

C --- Data --- 

      DATA LAY/100/
      DATA AAIR/14.01,16./ZAIR/7.,8./WAIR/.762,.238/

C --- Defines user tracking media ---      

      IFIELD =  0
      FIELDM =  0.
      TMAXFD =  .1
      DMAXMS =  10000.
      DEEMAX =  0.1
      EPSIL  =  0.05
      STMIN  =  1.      
      PAR(1) = 1.E7
      PAR(2) = 1.E7
      PAR(3) = 1.E7      

      CALL GSMATE(300,'VACUUM$',1.E-16,1.E-16,1.E-16,1.E+16,1.E+16,0,0)
      CALL GSTMED(300,'VACUUM$',300,0,IFIELD,FIELDM,TMAXFD,
     *     DMAXMS,DEEMAX,EPSIL,STMIN,0,0 )
      CALL GSVOLU('LABO','BOX ',300,PAR,3,IVOL)

C --- Defines atmospheric layers ---

      PRESSMIN=50.
      CALL STDZ2P(PRESSGG,3135.,0,TEMP,DENS)
      DPRESS=(PRESSGG-PRESSMIN)/LAY
      DO I=1,LAY+1
         PRESS(I)=PRESSGG-(I-1.)*DPRESS
         CALL STDP2Z(PRESS(I),HEIGHT(I),
     *        HFT,TEMP,DENSITY(I))
      ENDDO

      DO I=1,LAY	 
         WRITE(XNR,100)I+100
100      FORMAT('A',I3)
         PRESS1=PRESS(I)
         RHOI=0.
         DP=(PRESS(I+1)-PRESS(I))/1000.
300      CALL STDP2Z(PRESS1,H1,HFT1,T1,D1)
         CALL STDP2Z(PRESS1+DP,H2,HFT2,T2,D2)
         DH=H2-H1
         RHO=(D1+D2)/2.
         RHOI=RHOI+RHO*DH
         PRESS1=PRESS1+DP
         IF (PRESS1.GT.PRESS(I+1)) GOTO 300
         RMEAN=RHOI/(HEIGHT(I+1)-HEIGHT(I))/1000.
         DMAXMS=(HEIGHT(I+1)-HEIGHT(I))*LAY*1.E0
         CALL GSMIXT(I,XNR,AAIR,ZAIR,RMEAN,2,WAIR)
         CALL GSTMED(I,XNR,I,0,IFIELD,FIELDM,TMAXFD,
     *        DMAXMS,DEEMAX,EPSIL,STMIN,0,0 )
         CALL GSTPAR(I,'CUTHAD',1.E-5)
         PAR(1) = 1.E7
         PAR(2) = 1.E7
         PAR(3) = 0.5E2*(HEIGHT(I+1)-HEIGHT(I))
         CALL GSVOLU(XNR,'BOX ',I,PAR,3,IVOL)	 
         CALL GSPOS(XNR,1,'LABO',0.,0.,
     *        0.5*1.E2*(HEIGHT(I+1)+HEIGHT(I)),0,'ONLY')
      ENDDO

      PAR(1) = 1.E7
      PAR(2) = 1.E7
      PAR(3) = 0.5E2*HEIGHT(1)      
      CALL GSTMED(301,'DETL',300,0,IFIELD,FIELDM,TMAXFD,
     *        DMAXMS,DEEMAX,EPSIL,STMIN,0,0 )
      CALL GSVOLU('DETL','BOX ',301,PAR,3,IVOL)
      IDETL=IVOL
      CALL GSPOS('DETL',1,'LABO',0.,0.,0.5E2*HEIGHT(1),0,'ONLY')      
      CALL GGCLOS
 
      END
