C=======================================================================C
C UGINIT.F - Part of the SOLSPEC GEANT3 application                     C
C-----------------------------------------------------------------------C
C M. R. Moser, University of Bern, Switzerland                          C
C Last modification: 08/26/2002                                         C
C=======================================================================C

#include "geant321/pilot.h"

C=======================================================================C
      SUBROUTINE UGINIT
C-----------------------------------------------------------------------C
C     Routine to initialize GEANT/USER program and read data cards      C
C=======================================================================C

#include "geant321/gcunit.inc"
#include "geant321/gclist.inc"
#include "geant321/gckine.inc"
#include "geant321/gcflag.inc"
#include "pvolum.inc"
#include "celoss.inc"
#include "solspec.inc"

C --- Opens user files ---

      CALL UFILES
      
C --- Initializes GEANT ---

      CALL GINIT
      
      IPARTICLE=14
      CALL FFKEY('PART',IPARTICLE,1,'INTEGER')
      CALL FFKEY('SRCON',ISOURCEON,1,'INTEGER')
      CALL FFKEY('PHI',PHISTART,1,'REAL')
      CALL FFKEY('THETA',THETASTART,1,'REAL')
      CALL FFKEY('POSI',POSSTART,3,'REAL') 
      CALL FFKEY('SONDBG',ISONTELDEBUG,1,'INTEGER')
      CALL FFKEY('SPECTRUM',ISPECTRUM,1,'INTEGER')
      CALL FFKEY('NRTHETA',NRTHETA,1,'INTEGER')
      CALL FFKEY('NRPHI',NRPHI,1,'INTEGER')
      CALL FFKEY('ZENITHINT',ZENITHINT,1,'REAL')
      CALL FFKEY('COSEXP',COSEXP,1,'REAL')
      CALL FFKEY('TIME',TIME,1,'REAL')
      CALL FFKEY('FILENR',IFILENR,4,'INTEGER')
      CALL FFKEY('RNDM',NRNDM,2,'INTEGER')
                             
      IKINE=1
      PKINE(1)=0.001
      PKINE(2)=0.01

      CALL GFFGO
      CALL GZINIT
      CALL GPART
      
      PRINT*,IPARTICLE

C --- Prints version number ---

      WRITE(LOUT,10000)

C --- Geometry and materials description ---
 
      CALL UGEOM
      CALL GLOOK('MATE',LPRIN,NPRIN,IM)
      CALL GLOOK('TMED',LPRIN,NPRIN,IT)
      CALL GLOOK('VOLU',LPRIN,NPRIN,IV)
      IF(IM.NE.0)CALL GPRINT('MATE',0)
      IF(IT.NE.0)CALL GPRINT('TMED',0)
      IF(IV.NE.0)CALL GPRINT('VOLU',0)

C --- Energy loss and cross-sections initializations ---

      CALL FLINIT
      CALL GMORIN
      CALL GPHYSI
      
C --- Spectrum initialisation ---
      
      IF (ISPECTRUM.EQ.3) THEN
       CALL PROTON_INTSPEC
       IPARTICLE=14
      ELSE
       ISPECTRUM=0
      ENDIF 

C --- Defines user histograms ---
 
      CALL UHINIT

C --- Copy number initialization ---
  
      NCOPY=0
 
10000 FORMAT(/,'  VERSION 1.00 ',/)
 
      END
