C=======================================================================C
C UHINIT.F - Part of the SOLSPEC GEANT3 application                     C
C-----------------------------------------------------------------------C
C M. R. Moser, University of Bern, Switzerland                          C
C Last modification: 08/26/2002                                         C
C=======================================================================C

#include "geant321/pilot.h"

C=======================================================================C
      SUBROUTINE UHINIT
C-----------------------------------------------------------------------C
C     Routine to book the user histograms                               C
C=======================================================================C
 
#include "geant321/gckine.inc"
#include "pvolum.inc"
#include "solspec.inc"

C --- Histograms for shower development ---

      NBINS=BINLIMS(1)
      
C --- Directional energy distribution ---

      NRPHIMULT=4*(NRPHI-1)+1
      NRPART=9

      DO I=0,NRTHETA-1
        DO J=0,NRPHIMULT-1
          DO K=1,NRPART
            CALL HBOOK1(1000*K+100*I+J,'ENERGY DISTRIBUTION$',
     *        200,0.,2000.,0.)
          ENDDO
        ENDDO
      ENDDO
      
C --- Omnidirectional energy distribution ---
      
      DO K=1,NRPART
        CALL HBOOK1(10+K,'OMNIDIRECTIONAL ENERGY DISTRIBUTION$',
     *    200,0.,2000.,0.)        
      ENDDO

C --- Incident energies ---      

      CALL HBOOK1(1,'INCIDENT KINETIC ENERGY$',
     *  1000,40.,2000.,0.)

C --- Start Positions ---

      CALL HBOOK2(2,'START POSITION XY',
     *  250,-1.E7,1.E7,250,-1.E7,1.E7,0.)
      CALL HBOOK2(3,'START POSITION YZ',
     *  250,-1.E7,1.E7,250,0.,1.E7,0.)
      CALL HBOOK2(4,'START POSITION ZX',
     *  250,0.,1.E7,250,-1.E7,1.E7,0.)
     
C --- Incident direction ---

      CALL HBOOK2(5,'INCIDENT DIRECTION$',
     *  181,-1.,361.,202,-1.01,1.01,0.)
     
C --- Particle number ---

      CALL HBOOK1(6,'RESULTING PARTICLES$',
        50,0.5,50.5,0.)

      END
